/******************************************************************************
 *  File: analog.c
 *  Description: analog function
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/
#include "main.h"
#include "pmbus.h"
#include "analog.h"
#include "temperature.h"
#include "state.h"
#include "calibration.h"
#include "gateway.h"

#ifdef O3_CODE
#pragma GCC optimize ("O2")
#endif

voltage_t voltage;
current_t current;
temperature_t temperature;

// filter processing, analog A channels
int32_t iout_avg;

int32_t vout_pot_adj_avg;
int32_t vout_pot_adj_filt_prev;

int32_t iprog_avg;

void analogA_init(void)
{
	iout_avg = 0;
	current.iout_filt2 = 0;
}

#pragma CODE_SECTION(analogA_process, ".TI.ramfunc");
// In continuous loop ADC, ~910KHz (~1.1us) per loop (all A channels)
// ~1.3KHz (756us) sampling rate per channel
void analogA_process(void)
{

}

// Continuous scan loop, one loop is about 24.5KHz
void analogB_init(void)
{
//	ADC_CTRL2 |= ADC_CTRL2_START1_MASK;							// start ADC B conversion, continuous Loop parallel scan
}

#pragma CODE_SECTION(analogB_process, ".TI.ramfunc");
// ~440Hz sampling rate
// Note: VPROG ramp up is based on this rate, be careful if you change this sampling rate, VPROG response can also change (0v -> 5v, for SOC activation trigger point)
void analogB_process(void)
{

}
static inline int16_t cal_vprog2voutcnt(int16_t vprog_cnt)
{

}

// current.iset_ref = current.iprog_filt * 0.8981;
// IVPROG:0->5v ; ivprog_i:0v -> 3.1156v (30930) ; IPROG => 0A to 55A(iref=29780) ; 29780 / 30930 = 0.9628 * 32768 (Q15 format)
//                  temp1 = ((int32_t)current.iprog_filt * current.iprog_gain) >> 15;
int16_t cal_iprog2ioutcnt(int16_t iprog_cnt)
{

}

// every 250us
void vprog_process(void)
{

}

// process that handle vout adjustment using the potentiometer, every 10ms
void vout_adjust_process(void)
{

}

