/*
 * bootmode.h
 *
 *  Created on: May 27, 2021
 *      Author: ahugron
 */

#ifndef _BOOTMODE_H_
#define _BOOTMODE_H_

// for bootloading entry, shared memory with bootloader and application
typedef struct
{
	uint8_t  pwd0;
	uint8_t  pwd1;
	uint8_t  pwd2;
	uint8_t  pwd3;
	uint8_t  target_level;
	uint8_t  encryption_type;
	uint8_t  rfu0;
	uint8_t  rfu1;
} bootloader_share_data_t;

#define BOOT_ENTRY_0	0xC3u
#define BOOT_ENTRY_1	0x95u
#define BOOT_ENTRY_2	0x55u
#define BOOT_ENTRY_3	0x87u

extern bootloader_share_data_t bootloader_share_data;

void bootloader_init(void);
uint8_t bootloader_entry(uint8_t *buffer, uint8_t size, uint8_t type);

#endif /* _BOOTMODE_H_ */
