/*
 * control_soc.h
 *
 *  Created on: Oct 16, 2023
 *      Author: ahugron
 */

#ifndef CONTROL_SOC_H_
#define CONTROL_SOC_H_

#include "main.h"
#include "setup.h"
#include "analog.h"

#ifdef SOC_CTRL_ENABLE
/*lint -save -e9029*/
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!! DO NOT PUT THESE TABLES BELOW INTO FLASH, they are used during flash programming (Store command) !!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#if defined(HPT5K_60V) || defined(HPT5K_48V)

#if (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_HL)

#if defined(HPT5K_48V)
// see HPTK05_48V OTC.xlsx file, LOW PROFILE
soft_start_t soft_start_steps[SOFT_START_STEPS+1u] =
{
    {45612541, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {45646646, VOUT_PERCENTAGE_TO_COUNT(4) },
    {45715016, VOUT_PERCENTAGE_TO_COUNT(6) },
    {45817976, VOUT_PERCENTAGE_TO_COUNT(8) },
    {45956019, VOUT_PERCENTAGE_TO_COUNT(10)},
    {46094940, VOUT_PERCENTAGE_TO_COUNT(12)},
    {46304988, VOUT_PERCENTAGE_TO_COUNT(14)},
    {46517060, VOUT_PERCENTAGE_TO_COUNT(16)},
    {46767076, VOUT_PERCENTAGE_TO_COUNT(18)},
    {47019935, VOUT_PERCENTAGE_TO_COUNT(20)},
    {47349296, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {47683545, VOUT_PERCENTAGE_TO_COUNT(24)},
    {48098869, VOUT_PERCENTAGE_TO_COUNT(26)},
    {48483087, VOUT_PERCENTAGE_TO_COUNT(28)},
    {48952746, VOUT_PERCENTAGE_TO_COUNT(30)},
    {49472442, VOUT_PERCENTAGE_TO_COUNT(32)},
    {50003847, VOUT_PERCENTAGE_TO_COUNT(34)},
    {50589684, VOUT_PERCENTAGE_TO_COUNT(36)},
    {51190089, VOUT_PERCENTAGE_TO_COUNT(38)},
    {51894811, VOUT_PERCENTAGE_TO_COUNT(40)},
    {52620146, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {53367013, VOUT_PERCENTAGE_TO_COUNT(44)},
    {54185240, VOUT_PERCENTAGE_TO_COUNT(46)},
    {55080671, VOUT_PERCENTAGE_TO_COUNT(48)},
    {56060000, VOUT_PERCENTAGE_TO_COUNT(50)},
    {57076358, VOUT_PERCENTAGE_TO_COUNT(52)},
    {58473714, VOUT_PERCENTAGE_TO_COUNT(54)},
    {59400882, VOUT_PERCENTAGE_TO_COUNT(56)},
    {60400300, VOUT_PERCENTAGE_TO_COUNT(58)},
    {60477450, VOUT_PERCENTAGE_TO_COUNT(60)},
    {61915556, VOUT_PERCENTAGE_TO_COUNT(62)},   // 30
    {63658074, VOUT_PERCENTAGE_TO_COUNT(64)},
    {65416410, VOUT_PERCENTAGE_TO_COUNT(66)},
    {66926891, VOUT_PERCENTAGE_TO_COUNT(68)},
    {68506820, VOUT_PERCENTAGE_TO_COUNT(70)},
    {70067154, VOUT_PERCENTAGE_TO_COUNT(72)},
    {71502583, VOUT_PERCENTAGE_TO_COUNT(74)},
    {73200327, VOUT_PERCENTAGE_TO_COUNT(76)},
    {74978577, VOUT_PERCENTAGE_TO_COUNT(78)},
    {76675039, VOUT_PERCENTAGE_TO_COUNT(80)},
    {78448163, VOUT_PERCENTAGE_TO_COUNT(82)},   // 40
    {79664537, VOUT_PERCENTAGE_TO_COUNT(84)},
    {81868184, VOUT_PERCENTAGE_TO_COUNT(86)},
    {84193291, VOUT_PERCENTAGE_TO_COUNT(88)},
    {86506047,VOUT_PERCENTAGE_TO_COUNT(90)},
    {89097737,VOUT_PERCENTAGE_TO_COUNT(92)},    // 45
    {91925798,VOUT_PERCENTAGE_TO_COUNT(94)},
    {94934053,VOUT_PERCENTAGE_TO_COUNT(96)},
    {98140293,VOUT_PERCENTAGE_TO_COUNT(98)},
    {101172768,VOUT_PERCENTAGE_TO_COUNT(100)},
    {102960230,VOUT_PERCENTAGE_TO_COUNT(102)}   // 50
};
#else // HPT5K_60V
// see HPTK05_60V OTC.xlsx file
soft_start_t soft_start_steps[SOFT_START_STEPS+1u] =
{
    {49195925, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {49239928, VOUT_PERCENTAGE_TO_COUNT(4) },
    {49328172, VOUT_PERCENTAGE_TO_COUNT(6) },
    {49416732, VOUT_PERCENTAGE_TO_COUNT(8) },
    {49550171, VOUT_PERCENTAGE_TO_COUNT(10)},
    {49684332, VOUT_PERCENTAGE_TO_COUNT(12)},
    {49909556, VOUT_PERCENTAGE_TO_COUNT(14)},
    {50136831, VOUT_PERCENTAGE_TO_COUNT(16)},
    {50366185, VOUT_PERCENTAGE_TO_COUNT(18)},
    {50644195, VOUT_PERCENTAGE_TO_COUNT(20)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {51352836, VOUT_PERCENTAGE_TO_COUNT(24)},
    {51738947, VOUT_PERCENTAGE_TO_COUNT(26)},
    {52130909, VOUT_PERCENTAGE_TO_COUNT(28)},
    {52579026, VOUT_PERCENTAGE_TO_COUNT(30)},
    {53086056, VOUT_PERCENTAGE_TO_COUNT(32)},
    {53655205, VOUT_PERCENTAGE_TO_COUNT(34)},
    {54236690, VOUT_PERCENTAGE_TO_COUNT(36)},
    {54830916, VOUT_PERCENTAGE_TO_COUNT(38)},
    {55505384, VOUT_PERCENTAGE_TO_COUNT(40)},
    {56213867, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {56976030, VOUT_PERCENTAGE_TO_COUNT(44)},
    {57783395, VOUT_PERCENTAGE_TO_COUNT(46)},
    {58645190, VOUT_PERCENTAGE_TO_COUNT(48)},
    {59565289, VOUT_PERCENTAGE_TO_COUNT(50)},
    {60534682, VOUT_PERCENTAGE_TO_COUNT(52)},
    {65171351, VOUT_PERCENTAGE_TO_COUNT(54)},
    {66824763, VOUT_PERCENTAGE_TO_COUNT(56)},
    {67662537, VOUT_PERCENTAGE_TO_COUNT(58)},
    {68547180, VOUT_PERCENTAGE_TO_COUNT(60)},
    {69472792, VOUT_PERCENTAGE_TO_COUNT(62)},   // 30
    {70450781, VOUT_PERCENTAGE_TO_COUNT(64)},
    {71475253, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72568205, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73714837, VOUT_PERCENTAGE_TO_COUNT(70)},
    {74939069, VOUT_PERCENTAGE_TO_COUNT(72)},
    {76246870, VOUT_PERCENTAGE_TO_COUNT(74)},
    {77644908, VOUT_PERCENTAGE_TO_COUNT(76)},
    {79140656, VOUT_PERCENTAGE_TO_COUNT(78)},
    {82459916, VOUT_PERCENTAGE_TO_COUNT(80)},
    {84445835, VOUT_PERCENTAGE_TO_COUNT(82)},   // 40
    {86679641, VOUT_PERCENTAGE_TO_COUNT(84)},
    {89280311, VOUT_PERCENTAGE_TO_COUNT(86)},
    {92443728, VOUT_PERCENTAGE_TO_COUNT(88)},
    {96749104, VOUT_PERCENTAGE_TO_COUNT(90)},
    {101982660,VOUT_PERCENTAGE_TO_COUNT(92)},   // 45
    {107080801,VOUT_PERCENTAGE_TO_COUNT(94)},
    {111754446,VOUT_PERCENTAGE_TO_COUNT(96)},
    {114688000,VOUT_PERCENTAGE_TO_COUNT(98)},
    {117128170,VOUT_PERCENTAGE_TO_COUNT(100)},
    {117128170,VOUT_PERCENTAGE_TO_COUNT(102)}   // 50
};
#endif  // end of defined(HPT5K_48V)

#elif (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_LOW)

#if defined(HPT5K_48V)
// see HPLK05_48V OTC.xlsx file, LOW LINE
soft_start_t soft_start_steps[SOFT_START_STEPS+1u] =
{
    {43312541, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {43346646, VOUT_PERCENTAGE_TO_COUNT(4) },
    {43415016, VOUT_PERCENTAGE_TO_COUNT(6) },
    {43517976, VOUT_PERCENTAGE_TO_COUNT(8) },
    {43656019, VOUT_PERCENTAGE_TO_COUNT(10)},
    {43794940, VOUT_PERCENTAGE_TO_COUNT(12)},
    {44004988, VOUT_PERCENTAGE_TO_COUNT(14)},
    {44217060, VOUT_PERCENTAGE_TO_COUNT(16)},
    {44467076, VOUT_PERCENTAGE_TO_COUNT(18)},
    {44719935, VOUT_PERCENTAGE_TO_COUNT(20)},
    {45049296, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {45383545, VOUT_PERCENTAGE_TO_COUNT(24)},
    {45798869, VOUT_PERCENTAGE_TO_COUNT(26)},
    {46183087, VOUT_PERCENTAGE_TO_COUNT(28)},
    {46652746, VOUT_PERCENTAGE_TO_COUNT(30)},
    {47172442, VOUT_PERCENTAGE_TO_COUNT(32)},
    {47703847, VOUT_PERCENTAGE_TO_COUNT(34)},
    {48289684, VOUT_PERCENTAGE_TO_COUNT(36)},
    {48890089, VOUT_PERCENTAGE_TO_COUNT(38)},
    {49594811, VOUT_PERCENTAGE_TO_COUNT(40)},
    {50320146, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {51067013, VOUT_PERCENTAGE_TO_COUNT(44)},
    {51885240, VOUT_PERCENTAGE_TO_COUNT(46)},
    {52780671, VOUT_PERCENTAGE_TO_COUNT(48)},
    {53760000, VOUT_PERCENTAGE_TO_COUNT(50)},
    {54776358, VOUT_PERCENTAGE_TO_COUNT(52)},
    {56173714, VOUT_PERCENTAGE_TO_COUNT(54)},
    {57825882, VOUT_PERCENTAGE_TO_COUNT(56)},
    {59578182, VOUT_PERCENTAGE_TO_COUNT(58)},
    {61577450, VOUT_PERCENTAGE_TO_COUNT(60)},
    {63715556, VOUT_PERCENTAGE_TO_COUNT(62)},   // 30
    {65458074, VOUT_PERCENTAGE_TO_COUNT(64)},
    {67216410, VOUT_PERCENTAGE_TO_COUNT(66)},
    {68726891, VOUT_PERCENTAGE_TO_COUNT(68)},
    {70306820, VOUT_PERCENTAGE_TO_COUNT(70)},
    {71867154, VOUT_PERCENTAGE_TO_COUNT(72)},
    {73302583, VOUT_PERCENTAGE_TO_COUNT(74)},
    {75000327, VOUT_PERCENTAGE_TO_COUNT(76)},
    {76778577, VOUT_PERCENTAGE_TO_COUNT(78)},
    {78475039, VOUT_PERCENTAGE_TO_COUNT(80)},
    {80248163, VOUT_PERCENTAGE_TO_COUNT(82)},   // 40
    {82164537, VOUT_PERCENTAGE_TO_COUNT(84)},
    {84783983, VOUT_PERCENTAGE_TO_COUNT(86)},
    {86967204, VOUT_PERCENTAGE_TO_COUNT(88)},
    {89512585,VOUT_PERCENTAGE_TO_COUNT(90)},
    {92366174,VOUT_PERCENTAGE_TO_COUNT(92)},    // 45
    {95739548,VOUT_PERCENTAGE_TO_COUNT(94)},
    {99189622,VOUT_PERCENTAGE_TO_COUNT(96)},
    {102897645,VOUT_PERCENTAGE_TO_COUNT(98)},
    {106893670,VOUT_PERCENTAGE_TO_COUNT(100)},
    {110100480,VOUT_PERCENTAGE_TO_COUNT(102)}   // 50
};
#else
// see HPLK05_60V OTC.xlsx file (LOW LINE)
soft_start_t soft_start_steps[SOFT_START_STEPS+1u] =
{
    {43312541, VOUT_PERCENTAGE_TO_COUNT(2) },   //0 424
    {43346646, VOUT_PERCENTAGE_TO_COUNT(4) },
    {43415016, VOUT_PERCENTAGE_TO_COUNT(6) },
    {43517976, VOUT_PERCENTAGE_TO_COUNT(8) },
    {43656019, VOUT_PERCENTAGE_TO_COUNT(10)},
    {43829809, VOUT_PERCENTAGE_TO_COUNT(12)},
    {44040192, VOUT_PERCENTAGE_TO_COUNT(14)},
    {44288206, VOUT_PERCENTAGE_TO_COUNT(16)},
    {44539029, VOUT_PERCENTAGE_TO_COUNT(18)},
    {44865721, VOUT_PERCENTAGE_TO_COUNT(20)},
    {45197241, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {45571391, VOUT_PERCENTAGE_TO_COUNT(24)},
    {45990175, VOUT_PERCENTAGE_TO_COUNT(26)},
    {46455899, VOUT_PERCENTAGE_TO_COUNT(28)},
    {46971195, VOUT_PERCENTAGE_TO_COUNT(30)},
    {47498050, VOUT_PERCENTAGE_TO_COUNT(32)},
    {48120839, VOUT_PERCENTAGE_TO_COUNT(34)},
    {48760177, VOUT_PERCENTAGE_TO_COUNT(36)},
    {49416732, VOUT_PERCENTAGE_TO_COUNT(38)},
    {50182534, VOUT_PERCENTAGE_TO_COUNT(40)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {51836384, VOUT_PERCENTAGE_TO_COUNT(44)},
    {52780671, VOUT_PERCENTAGE_TO_COUNT(46)},
    {53760000, VOUT_PERCENTAGE_TO_COUNT(48)},
    {54830916, VOUT_PERCENTAGE_TO_COUNT(50)},
    {55939681, VOUT_PERCENTAGE_TO_COUNT(52)},
    {57463716, VOUT_PERCENTAGE_TO_COUNT(54)},
    {59642730, VOUT_PERCENTAGE_TO_COUNT(56)},
    {63937561, VOUT_PERCENTAGE_TO_COUNT(58)},
    {66325590, VOUT_PERCENTAGE_TO_COUNT(60)},
    {68106198, VOUT_PERCENTAGE_TO_COUNT(62)},   // 30
    {69446499, VOUT_PERCENTAGE_TO_COUNT(64)},
    {70831498, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72263376, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73764224, VOUT_PERCENTAGE_TO_COUNT(70)},
    {75328736, VOUT_PERCENTAGE_TO_COUNT(72)},
    {76971812, VOUT_PERCENTAGE_TO_COUNT(74)},
    {78710666, VOUT_PERCENTAGE_TO_COUNT(76)},
    {80565257, VOUT_PERCENTAGE_TO_COUNT(78)},
    {82571231, VOUT_PERCENTAGE_TO_COUNT(80)},
    {84757875, VOUT_PERCENTAGE_TO_COUNT(82)},   // 40
    {87201394, VOUT_PERCENTAGE_TO_COUNT(84)},
    {90024922, VOUT_PERCENTAGE_TO_COUNT(86)},
    {94151257, VOUT_PERCENTAGE_TO_COUNT(88)},
    {97899001,VOUT_PERCENTAGE_TO_COUNT(90)},
    {101957476,VOUT_PERCENTAGE_TO_COUNT(92)},   // 45
    {106366998,VOUT_PERCENTAGE_TO_COUNT(94)},
    {111175173,VOUT_PERCENTAGE_TO_COUNT(96)},
    {116438622,VOUT_PERCENTAGE_TO_COUNT(98)},
    {122225222,VOUT_PERCENTAGE_TO_COUNT(100)},
    {119674435,VOUT_PERCENTAGE_TO_COUNT(102)}   // 50
};
#endif
#endif  // MFR_PRODUCT_CODE_LINE

#elif defined(HPT5K_80V) || defined(HPT5K_100V)

#if (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_HL)
// see HPTK05_100V OTC.xlsx file
soft_start_t soft_start_steps[SOFT_START_STEPS+1] =
{
    {47011307, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {47051487, VOUT_PERCENTAGE_TO_COUNT(4) },
    {47132055, VOUT_PERCENTAGE_TO_COUNT(6) },
    {47253425, VOUT_PERCENTAGE_TO_COUNT(8) },
    {47375422, VOUT_PERCENTAGE_TO_COUNT(10)},
    {47539067, VOUT_PERCENTAGE_TO_COUNT(12)},
    {47703847, VOUT_PERCENTAGE_TO_COUNT(14)},
    {47953171, VOUT_PERCENTAGE_TO_COUNT(16)},
    {48205114, VOUT_PERCENTAGE_TO_COUNT(18)},
    {48502414, VOUT_PERCENTAGE_TO_COUNT(20)},
    {48803404, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {49152000, VOUT_PERCENTAGE_TO_COUNT(24)},
    {49550171, VOUT_PERCENTAGE_TO_COUNT(26)},
    {50000218, VOUT_PERCENTAGE_TO_COUNT(28)},
    {50458515, VOUT_PERCENTAGE_TO_COUNT(30)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(32)},
    {51496950, VOUT_PERCENTAGE_TO_COUNT(34)},
    {52081589, VOUT_PERCENTAGE_TO_COUNT(36)},
    {52730115, VOUT_PERCENTAGE_TO_COUNT(38)},
    {53394995, VOUT_PERCENTAGE_TO_COUNT(40)},
    {54130029, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {54885583, VOUT_PERCENTAGE_TO_COUNT(44)},
    {55741434, VOUT_PERCENTAGE_TO_COUNT(46)},
    {56630223, VOUT_PERCENTAGE_TO_COUNT(48)},
    {57571889, VOUT_PERCENTAGE_TO_COUNT(50)},
    {58576548, VOUT_PERCENTAGE_TO_COUNT(52)},
    {59642730, VOUT_PERCENTAGE_TO_COUNT(54)},
    {64575062, VOUT_PERCENTAGE_TO_COUNT(56)},
    {66646780, VOUT_PERCENTAGE_TO_COUNT(58)},
    {67645908, VOUT_PERCENTAGE_TO_COUNT(60)},
    {68684017, VOUT_PERCENTAGE_TO_COUNT(62)},   //30
    {69772167, VOUT_PERCENTAGE_TO_COUNT(64)},
    {70895351, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72074156, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73312345, VOUT_PERCENTAGE_TO_COUNT(70)},
    {74624156, VOUT_PERCENTAGE_TO_COUNT(72)},
    {75994257, VOUT_PERCENTAGE_TO_COUNT(74)},
    {77459181, VOUT_PERCENTAGE_TO_COUNT(76)},
    {79015703, VOUT_PERCENTAGE_TO_COUNT(78)},
    {80695163, VOUT_PERCENTAGE_TO_COUNT(80)},
    {82521721, VOUT_PERCENTAGE_TO_COUNT(82)},   //40
    {84523630, VOUT_PERCENTAGE_TO_COUNT(84)},
    {86761608, VOUT_PERCENTAGE_TO_COUNT(86)},
    {89323771, VOUT_PERCENTAGE_TO_COUNT(88)},
    {92443728, VOUT_PERCENTAGE_TO_COUNT(90)},
    {96749104, VOUT_PERCENTAGE_TO_COUNT(92)},   //45
    {101982660, VOUT_PERCENTAGE_TO_COUNT(94)},
    {107080801, VOUT_PERCENTAGE_TO_COUNT(96)},
    {111754446, VOUT_PERCENTAGE_TO_COUNT(98)},
    {114688000, VOUT_PERCENTAGE_TO_COUNT(100)},
    {114688000, VOUT_PERCENTAGE_TO_COUNT(102)}  //50
};
#elif (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_LOW)
// see HPLK05_100V OTC.xlsx file
soft_start_t soft_start_steps[SOFT_START_STEPS+1] =
{
    {43312541, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {43346646, VOUT_PERCENTAGE_TO_COUNT(4) },
    {43415016, VOUT_PERCENTAGE_TO_COUNT(6) },
    {43517976, VOUT_PERCENTAGE_TO_COUNT(8) },
    {43656019, VOUT_PERCENTAGE_TO_COUNT(10)},
    {43829809, VOUT_PERCENTAGE_TO_COUNT(12)},
    {44040192, VOUT_PERCENTAGE_TO_COUNT(14)},
    {44288206, VOUT_PERCENTAGE_TO_COUNT(16)},
    {44539029, VOUT_PERCENTAGE_TO_COUNT(18)},
    {44865721, VOUT_PERCENTAGE_TO_COUNT(20)},
    {45197241, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {45571391, VOUT_PERCENTAGE_TO_COUNT(24)},
    {45990175, VOUT_PERCENTAGE_TO_COUNT(26)},
    {46455899, VOUT_PERCENTAGE_TO_COUNT(28)},
    {46971195, VOUT_PERCENTAGE_TO_COUNT(30)},
    {47498050, VOUT_PERCENTAGE_TO_COUNT(32)},
    {48120839, VOUT_PERCENTAGE_TO_COUNT(34)},
    {48760177, VOUT_PERCENTAGE_TO_COUNT(36)},
    {49416732, VOUT_PERCENTAGE_TO_COUNT(38)},
    {50182534, VOUT_PERCENTAGE_TO_COUNT(40)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {51836384, VOUT_PERCENTAGE_TO_COUNT(44)},
    {52780671, VOUT_PERCENTAGE_TO_COUNT(46)},
    {53760000, VOUT_PERCENTAGE_TO_COUNT(48)},
    {55050240, VOUT_PERCENTAGE_TO_COUNT(50)},
    {56288589, VOUT_PERCENTAGE_TO_COUNT(52)},
    {57825882, VOUT_PERCENTAGE_TO_COUNT(54)},
    {59967582, VOUT_PERCENTAGE_TO_COUNT(56)},
    {63789386, VOUT_PERCENTAGE_TO_COUNT(58)},
    {66566191, VOUT_PERCENTAGE_TO_COUNT(60)},
    {68123054, VOUT_PERCENTAGE_TO_COUNT(62)},   //30
    {69464025, VOUT_PERCENTAGE_TO_COUNT(64)},
    {70849730, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72291845, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73793887, VOUT_PERCENTAGE_TO_COUNT(70)},
    {75359671, VOUT_PERCENTAGE_TO_COUNT(72)},
    {77004112, VOUT_PERCENTAGE_TO_COUNT(74)},
    {78733181, VOUT_PERCENTAGE_TO_COUNT(76)},
    {80588845, VOUT_PERCENTAGE_TO_COUNT(78)},
    {82583618, VOUT_PERCENTAGE_TO_COUNT(80)},
    {84770927, VOUT_PERCENTAGE_TO_COUNT(82)},   //40
    {87201394, VOUT_PERCENTAGE_TO_COUNT(84)},
    {90246295, VOUT_PERCENTAGE_TO_COUNT(86)},
    {94151257, VOUT_PERCENTAGE_TO_COUNT(88)},
    {97881594, VOUT_PERCENTAGE_TO_COUNT(90)},
    {101919724, VOUT_PERCENTAGE_TO_COUNT(92)},  //45
    {106305378, VOUT_PERCENTAGE_TO_COUNT(94)},
    {111085438, VOUT_PERCENTAGE_TO_COUNT(96)},
    {116315611, VOUT_PERCENTAGE_TO_COUNT(98)},
    {122062616, VOUT_PERCENTAGE_TO_COUNT(100)},
    {123987027, VOUT_PERCENTAGE_TO_COUNT(102)}  //50
};
#endif  // MFR_PRODUCT_CODE_LINE

#elif HPT5K_200V || HPT5K_400V || HPT5K_800V
#if (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_HL)
// see HPTK05_200V OTC.xlsx file
soft_start_t soft_start_steps[SOFT_START_STEPS+1] =
{
    {47011307, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {47051487, VOUT_PERCENTAGE_TO_COUNT(4) },
    {47132055, VOUT_PERCENTAGE_TO_COUNT(6) },
    {47253425, VOUT_PERCENTAGE_TO_COUNT(8) },
    {47375422, VOUT_PERCENTAGE_TO_COUNT(10)},
    {47539067, VOUT_PERCENTAGE_TO_COUNT(12)},
    {47703847, VOUT_PERCENTAGE_TO_COUNT(14)},
    {47953171, VOUT_PERCENTAGE_TO_COUNT(16)},
    {48205114, VOUT_PERCENTAGE_TO_COUNT(18)},
    {48502414, VOUT_PERCENTAGE_TO_COUNT(20)},
    {48803404, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {49152000, VOUT_PERCENTAGE_TO_COUNT(24)},
    {49550171, VOUT_PERCENTAGE_TO_COUNT(26)},
    {50000218, VOUT_PERCENTAGE_TO_COUNT(28)},
    {50458515, VOUT_PERCENTAGE_TO_COUNT(30)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(32)},
    {51496950, VOUT_PERCENTAGE_TO_COUNT(34)},
    {52081589, VOUT_PERCENTAGE_TO_COUNT(36)},
    {52730115, VOUT_PERCENTAGE_TO_COUNT(38)},
    {53394995, VOUT_PERCENTAGE_TO_COUNT(40)},
    {54130029, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {54885583, VOUT_PERCENTAGE_TO_COUNT(44)},
    {55741434, VOUT_PERCENTAGE_TO_COUNT(46)},
    {56630223, VOUT_PERCENTAGE_TO_COUNT(48)},
    {57571889, VOUT_PERCENTAGE_TO_COUNT(50)},
    {58576548, VOUT_PERCENTAGE_TO_COUNT(52)},
    {59642730, VOUT_PERCENTAGE_TO_COUNT(54)},
    {64469188, VOUT_PERCENTAGE_TO_COUNT(56)},
    {66638712, VOUT_PERCENTAGE_TO_COUNT(58)},
    {67645908, VOUT_PERCENTAGE_TO_COUNT(60)},
    {68701161, VOUT_PERCENTAGE_TO_COUNT(62)},   //30
    {69789858, VOUT_PERCENTAGE_TO_COUNT(64)},
    {70931890, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72111920, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73361194, VOUT_PERCENTAGE_TO_COUNT(70)},
    {74664641, VOUT_PERCENTAGE_TO_COUNT(72)},
    {76046747, VOUT_PERCENTAGE_TO_COUNT(74)},
    {77513714, VOUT_PERCENTAGE_TO_COUNT(76)},
    {79072450, VOUT_PERCENTAGE_TO_COUNT(78)},
    {80742505, VOUT_PERCENTAGE_TO_COUNT(80)},
    {82558848, VOUT_PERCENTAGE_TO_COUNT(82)},   //40
    {84549593, VOUT_PERCENTAGE_TO_COUNT(84)},
    {86775284, VOUT_PERCENTAGE_TO_COUNT(86)},
    {89338267, VOUT_PERCENTAGE_TO_COUNT(88)},
    {92443728, VOUT_PERCENTAGE_TO_COUNT(90)},
    {96749104, VOUT_PERCENTAGE_TO_COUNT(92)},   //45
    {101982660, VOUT_PERCENTAGE_TO_COUNT(94)},
    {107080801, VOUT_PERCENTAGE_TO_COUNT(96)},
    {111754446, VOUT_PERCENTAGE_TO_COUNT(98)},
    {114688000, VOUT_PERCENTAGE_TO_COUNT(100)},
    {114688000, VOUT_PERCENTAGE_TO_COUNT(102)}  //50
};
#elif (MFR_PRODUCT_CODE_LINE == MFR_PRODUCT_CODE_LINE_LOW)
// see HPLK05_200V OTC.xlsx file
soft_start_t soft_start_steps[SOFT_START_STEPS+1] =
{
    {43312541, VOUT_PERCENTAGE_TO_COUNT(2) },   //0
    {43346646, VOUT_PERCENTAGE_TO_COUNT(4) },
    {43415016, VOUT_PERCENTAGE_TO_COUNT(6) },
    {43517976, VOUT_PERCENTAGE_TO_COUNT(8) },
    {43656019, VOUT_PERCENTAGE_TO_COUNT(10)},
    {43829809, VOUT_PERCENTAGE_TO_COUNT(12)},
    {44040192, VOUT_PERCENTAGE_TO_COUNT(14)},
    {44288206, VOUT_PERCENTAGE_TO_COUNT(16)},
    {44539029, VOUT_PERCENTAGE_TO_COUNT(18)},
    {44865721, VOUT_PERCENTAGE_TO_COUNT(20)},
    {45197241, VOUT_PERCENTAGE_TO_COUNT(22)},   //10
    {45571391, VOUT_PERCENTAGE_TO_COUNT(24)},
    {45990175, VOUT_PERCENTAGE_TO_COUNT(26)},
    {46455899, VOUT_PERCENTAGE_TO_COUNT(28)},
    {46971195, VOUT_PERCENTAGE_TO_COUNT(30)},
    {47498050, VOUT_PERCENTAGE_TO_COUNT(32)},
    {48120839, VOUT_PERCENTAGE_TO_COUNT(34)},
    {48760177, VOUT_PERCENTAGE_TO_COUNT(36)},
    {49416732, VOUT_PERCENTAGE_TO_COUNT(38)},
    {50182534, VOUT_PERCENTAGE_TO_COUNT(40)},
    {50972444, VOUT_PERCENTAGE_TO_COUNT(42)},   //20
    {51836384, VOUT_PERCENTAGE_TO_COUNT(44)},
    {52780671, VOUT_PERCENTAGE_TO_COUNT(46)},
    {53760000, VOUT_PERCENTAGE_TO_COUNT(48)},
    {55050240, VOUT_PERCENTAGE_TO_COUNT(50)},
    {56288589, VOUT_PERCENTAGE_TO_COUNT(52)},
    {57825882, VOUT_PERCENTAGE_TO_COUNT(54)},
    {59967582, VOUT_PERCENTAGE_TO_COUNT(56)},
    {64011907, VOUT_PERCENTAGE_TO_COUNT(58)},
    {66646780, VOUT_PERCENTAGE_TO_COUNT(60)},
    {68139918, VOUT_PERCENTAGE_TO_COUNT(62)},   //30
    {69490331, VOUT_PERCENTAGE_TO_COUNT(64)},
    {70886222, VOUT_PERCENTAGE_TO_COUNT(66)},
    {72329838, VOUT_PERCENTAGE_TO_COUNT(68)},
    {73823575, VOUT_PERCENTAGE_TO_COUNT(70)},
    {75390633, VOUT_PERCENTAGE_TO_COUNT(72)},
    {77036440, VOUT_PERCENTAGE_TO_COUNT(74)},
    {78766977, VOUT_PERCENTAGE_TO_COUNT(76)},
    {80624253, VOUT_PERCENTAGE_TO_COUNT(78)},
    {82608403, VOUT_PERCENTAGE_TO_COUNT(80)},
    {84783983, VOUT_PERCENTAGE_TO_COUNT(82)},   //40
    {87215209, VOUT_PERCENTAGE_TO_COUNT(84)},
    {90024922, VOUT_PERCENTAGE_TO_COUNT(86)},
    {94167362, VOUT_PERCENTAGE_TO_COUNT(88)},
    {97872893, VOUT_PERCENTAGE_TO_COUNT(90)},
    {101881999, VOUT_PERCENTAGE_TO_COUNT(92)},  //45
    {106233578, VOUT_PERCENTAGE_TO_COUNT(94)},
    {110973471, VOUT_PERCENTAGE_TO_COUNT(96)},
    {116156084, VOUT_PERCENTAGE_TO_COUNT(98)},
    {121846481, VOUT_PERCENTAGE_TO_COUNT(100)},
    {123987027, VOUT_PERCENTAGE_TO_COUNT(102)}  //50
};
#endif  // MFR_PRODUCT_CODE_LINE

#endif
/*lint -restore */

#endif


#endif /* CONTROL_SOC_H_ */
