/******************************************************************************
 *  File: digital_io.h
 *  Description: general IO function
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/
#ifndef DIGITAL_IO_H_
#define DIGITAL_IO_H_

#include "setup.h"

// input signals
#define IS_P2S_UART()		(HWREG(GPIODATA_BASE+GPIO_O_GPADAT) & GPIO_GPADAT_GPIO17)	// UART RX state pin
#define IS_SYNC_ON()        (HWREG(GPIODATA_BASE+GPIO_O_GPHDAT) & GPIO_GPHDAT_GPIO230)  // AIO

#define IS_EXT_WDT_FAULT()  (HWREG(GPIODATA_BASE+GPIO_O_GPADAT) & GPIO_GPADAT_GPIO23)
#define IS_HW_IMB_FAULT()   (HWREG(GPIODATA_BASE+GPIO_O_GPADAT) & GPIO_GPADAT_GPIO8)
#define IS_CAP_OVP_FAULT()  (HWREG(GPIODATA_BASE+GPIO_O_GPHDAT) & GPIO_GPHDAT_GPIO225)  // AIO
#define IS_OVP_FAULT()      ((HWREG(GPIODATA_BASE+GPIO_O_GPADAT) & GPIO_GPADAT_GPIO28) == 0u)

// Output signals
#define ISHARE_PROT_ON()	{HWREG(GPIODATA_BASE+GPIO_O_GPASET) = GPIO_GPASET_GPIO11; status.bits.ishare_enable = 0;}
#define ISHARE_PROT_OFF()	{HWREG(GPIODATA_BASE+GPIO_O_GPACLEAR) = GPIO_GPACLEAR_GPIO11; status.bits.ishare_enable = 1;}
#define SYNC_SIG_ON()		HWREG(GPIODATA_BASE+GPIO_O_GPACLEAR) = GPIO_GPACLEAR_GPIO7;
#define SYNC_SIG_OFF()		HWREG(GPIODATA_BASE+GPIO_O_GPASET) = GPIO_GPASET_GPIO7;

#define EXT_WATCHDOG_CLR()  HWREG(GPIODATA_BASE+GPIO_O_GPBCLEAR) = GPIO_GPBCLEAR_GPIO41;
#define EXT_WATCHDOG_SET()  HWREG(GPIODATA_BASE+GPIO_O_GPBSET) = GPIO_GPBSET_GPIO41;

#define DEBUG0_SIG_ON()	    HWREG(GPIODATA_BASE+GPIO_O_GPBSET) = GPIO_GPBSET_GPIO40;
#define DEBUG0_SIG_OFF()	HWREG(GPIODATA_BASE+GPIO_O_GPBCLEAR) = GPIO_GPBCLEAR_GPIO40;
#define DEBUG0_SIG_TGL()	HWREG(GPIODATA_BASE+GPIO_O_GPBTOGGLE) = GPIO_GPBTOGGLE_GPIO40;

#define DEBUG1_SIG_ON()     HWREG(GPIODATA_BASE+GPIO_O_GPASET) = GPIO_GPASET_GPIO24;
#define DEBUG1_SIG_OFF()    HWREG(GPIODATA_BASE+GPIO_O_GPACLEAR) = GPIO_GPACLEAR_GPIO24;
#define DEBUG1_SIG_TGL()    HWREG(GPIODATA_BASE+GPIO_O_GPATOGGLE) = GPIO_GPATOGGLE_GPIO24;

void io_init(void);
void io_process(void);

#endif /* DIGITAL_IO_H_ */

