/******************************************************************************
 *  File: fan.c
 *  Description: fan function
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/
#include "main.h"
#include "fan.h"
#include "pmbus.h"
#include "timer.h"
#include "analog.h"
#include "calibration.h"
#include "primary.h"
#include "pri_comm.h"
#include "state.h"
#include "digital_io.h"

/*__attribute__ ((section(".m_data_2")))*/ fan_t fan;

// filter for iout
#define FILTER_IOUT_MAX_POLE	0x03					// RC pole
#define FILTER_IOUT_MAX_GAIN	0x02					// scale up
#define	FILTER_IOUT_MAX_SCALE	(FILTER_IOUT_MAX_POLE + FILTER_IOUT_MAX_GAIN)

#define FAN_HICCUP_COLD_CNT		12u	// seconds

static int16_t worst_pfc_temp;
static int16_t worst_sec_temp;

static void fan_speed_curve(void);

void fan_init(void)
{
	fan.fan1_speed = 0;
	fan.fan2_speed = 0;
	fan.fan3_speed = 0;
	fan.fan4_speed = 0;
	fan.fan_ctrl_pwm = 0;
	fan.fan_ctrl = 0;
	fan.fan_cold_hiccup_cnt = 0;
	fan.fan_preload_offset = 0;
	fan.fan_acok_cnt = 0;

	fan.fan_select = 1;

	// init fan tach pulse counter (using LPTMR0), input filter at 16us
	INIT_FAN_COUNTER();

	current.iout_max = 0;
}

// Get and verify fan speed, need to be every 1s. Calculate number of tachometer pulse in 1s
void fan_speed(void)
{

}

// fan speed depending on worst case temperature and max current
static void fan_speed_curve(void)
{

}

// executed every 1s
void fan_process(void)
{

}

// executed every 100ms
void fan_pwm_process(void)
{

}
