/******************************************************************************
 *  File: power.h
 *  Description: power limit
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/

#ifndef POWER_H_
#define POWER_H_

#define POWER_LIMIT_LL	(MFR_LL_POUT_MAX * RVU * RVI)
#define POWER_LIMIT_HL	(5400ul * RVU * RVI)		// W in full scale

#define PFC_DEFAULT_MAX_ADJ 164		// +36
#define PFC_DEFAULT_MIN_ADJ 94		// -34

// coefficient for ishare loop
#define ISHARE_Kp		5000
#define ISHARE_Ki		500
#define ISHARE_Kd		0

#define	LOADSHARE_ADJ_MAX	VOUT_PERCENTAGE_TO_COUNT(4)
#define	LOADSHARE_ADJ_MIN	0
#define LOADSHARE_SHIFT		16
#define	LOADSHARE_INT0_MAX	(((int32_t)LOADSHARE_ADJ_MAX) << LOADSHARE_SHIFT)
#define	LOADSHARE_INT0_MIN (((int32_t)LOADSHARE_ADJ_MIN) << LOADSHARE_SHIFT)

typedef struct
{
    int16_t 	vout_adj;
    uint16_t 	kp;
    uint16_t 	ki;
    int32_t 	threshold;
    int32_t 	control;
    int32_t  	integrator;
}ishare_t;

extern uint8_t dcbus_target;
extern uint8_t dcbus_target_set;
extern ishare_t ishare;

void power_ishare_init(void);
void power_ishare_process(void);
void power_internal_llc_ishare_process(void);
void power_capibility(void);
void power_protection(void);

#endif /* POWER_H_ */
