/******************************************************************************
 *  File: primary.c
 *  Description:
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 ****************************************************************************/
#include "main.h"
#include "setup.h"
#include "primary.h"
#include "pri_comm.h"
#include "pmbus.h"
#include "state.h"

#ifdef O3_CODE
#pragma GCC optimize ("O3")
#endif

primary_status_t primary_status;
uint16_t pfc_uv_limit;

void primary_init(void)
{
	primary_status.all = 0;
	primary_status.bits.ac_uv = 1;
	primary_status.bits.pfc_uv = 1;			// primary not good by default
	primary_status.bits.relay_open = 1;		// relay open by default
	primary_status.bits.boost_not_rdy = 1;	// boost not ready by default
	primary_status.bits.vin_low = 1;		// low vin by default
	primary_status.bits.vin_loss = 1;
	primary_status.bits.vin_imbalance = 1;
	primary_status.bits.pfc_off = 1;

	pfc_uv_limit = 0;
}

// 10ms
void primary_process(void)
{

}
