/******************************************************************************
 *  File: primary.h
 *  Description:
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/

#include "main.h"

#ifndef PRIMARY_H_
#define PRIMARY_H_

typedef union
{
	uint16_t all;
	struct
	{
		unsigned quick_acf 		:1;		// ac early warning from break character
		unsigned ac_uv	    	:1;
		unsigned ac_ov	    	:1;
		unsigned relay_open 	:1;

		unsigned pfc_uv			:1;
		unsigned pfc_ov			:1;
		unsigned pfc_too_low	:1;
		unsigned boost_not_rdy	:1;

		unsigned pfc_off		:1;
		unsigned pfc_latch		:1;
		unsigned pfc_otp		:1;
		unsigned pfc_otw		:1;

		unsigned ac_quick_fault	:1;		// from all PFCs status register
		unsigned vin_low		:1;
		unsigned vin_loss		:1;
		unsigned vin_imbalance	:1;
	} bits;
} primary_status_t;

#define PRIMARY_SD_MASK 0x8076u		// flags that can cause the output to SD

extern uint16_t pfc_uv_limit;
extern primary_status_t primary_status;

//***************************************************************************************************
void primary_init(void);
void primary_process(void);
void primary_bus_adjust(void);
//***************************************************************************************************

#endif /* PRIMARY_H_ */
