/******************************************************************************
 *  File: restart.c
 *  Description: fault restart state
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 ****************************************************************************/
#include "main.h"
#include "restart.h"
#include "timer.h"
#include "pmbus.h"
#include "control.h"
#include "calibration.h"

#ifdef O3_CODE
#pragma GCC optimize ("O3")
#endif

/*__attribute__ ((section(".m_data_2")))*/ restart_t restart;
/*__attribute__ ((section(".m_data_2")))*/ restart_flags_t restart_flags;

static void restart_clear_retry_counter(void);

void restart_init(void)
{
	restart_clear_retry_counter();

	restart.wait_timer_10ms = 0;
	restart.state = RESTART_STATE_IDLE;
	restart_flags.all = 0;
}

static void restart_clear_retry_counter(void)
{
	restart.reset_timer_s = RESTART_RESET_S;
	restart.uv_retry_counter = 0;
	restart.ocp_retry_counter = 0;
	restart.ocpx_retry_counter = 0;
	restart.ovp_retry_counter = 0;
	restart.input_retry_counter = 0;
	restart.input_ov_retry_counter = 0;
	restart.fan_otp_retry_counter = 0;
	restart.pricomm_retry_counter = 0;
	restart.ovp_max_retry = OVP_MAX_RESTART_RETRIES;
}

void restart_clear_fault(void)
{

}

void restart_process(void)
{

}
