/******************************************************************************
 *  File: setup.h
 *  Description:
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 ****************************************************************************/
#ifndef SETUP_H_
#define SETUP_H_

#include "main.h"

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!! WARNING WARNING WARNING WARNING !!!!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!! Change GPIOE16 to OUTPUT for LOW PROFILE !!!!!!!
//!!! Change GPIOE16 to INPUT for standard 5*5 !!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

/////////////////////////////////////
// *** SELECT ONLY ONE PRODUCT *** //
/////////////////////////////////////
//#define HPT5K0TS048 				1	// 5*5
//#define HPT5K0TS048_LOWPROFILE 		1	// low profile	!!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS048 				1	// Low Line only

//#define HPT5K0TS060 				1	// 5*5
//#define HPT5K0TS060_LOWPROFILE 		1	// low profile	!!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS060 				1	// Low Line only

//#define HPT5K0TS080 				1	// 5*5

//#define HPT5K0TS100 				1	// 5*5
//#define HPT5K0TS100_LOWPROFILE 		1	// low profile	!!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS100 				1	// Low Line only

//#define HPT5K0TS200 				1	// 5*5
//#define HPT5K0TS200_LOWPROFILE 		1	// low profile	!!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS200 				1	// Low Line only

#define HPT5K0TS400               1   // 5*5
//#define HPT5K0TS400_LOWPROFILE        1   // low profile  !!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS400               1   // Low Line only

//#define HPT5K0TS800               1   // 5*5
//#define HPT5K0TS800_LOWPROFILE        1   // low profile  !!! Change GPIOE16 to OUTPUT for LOW PROFILE
//#define HPL5K0TS800               1   // Low Line only

///////////////////////
// communication option
///////////////////////
//#define CANBUS_SUPPORT 1
//#define MODBUS_SUPPORT 1
//#define SCPI_SUPPORT 1

#define VLOOP_DERIVATIVE    1
//#define SOC_CTRL_ENABLE     1

#define TI_DSP      1
//#define KINETIS_DSP 1
///////////////
// debug option
///////////////
#define OPEN_LOOP 1
//#define DEBUG_SIG_IO 1
//#define O3_CODE 1		// code optimization -O3
//#define OTP_DISABLE 1
#define DISABLE_SHORT3_CTRL_PROTECTION 1
#define BYPASS_INTERNAL_COMMS 1
#define DISABLE_SAFETY_LATCH 1
//#define TEMPERATURE_EMULATION 1
/////////////////////////////////
// no option to change below that
/////////////////////////////////
#if (defined(HPT5K0TS048_LOWPROFILE) || defined(HPT5K0TS060_LOWPROFILE) || defined(HPT5K0TS100_LOWPROFILE) || defined(HPT5K0TS200_LOWPROFILE) || defined(HPT5K0TS400_LOWPROFILE) || defined(HPT5K0TS800_LOWPROFILE))
#define HPT5K_LOW_PROFILE	1		// WARNING !!!!! Change GPIOE16 to OUTPUT for Low profile (INPUT for 5*5) !!!!!
#endif

#if (defined(HPL5K0TS048) || defined(HPL5K0TS060) || defined(HPL5K0TS100) || defined(HPL5K0TS200) || defined(HPL5K0TS400) || defined(HPL5K0TS800))
#define HPT5K_LOW_LINE	1	// HPL5K0 low line only
#endif

#if (defined(HPT5K0TS048) || defined(HPT5K0TS048_LOWPROFILE) || defined(HPL5K0TS048))
#define HPT5K_48V 1
#endif
#if (defined(HPT5K0TS060) || defined(HPT5K0TS060_LOWPROFILE) || defined(HPL5K0TS060))
#define HPT5K_60V 1
#endif
#if (defined(HPT5K0TS100) || defined(HPT5K0TS100_LOWPROFILE) || defined(HPL5K0TS100))
#define HPT5K_100V 1
#endif
#if (defined(HPT5K0TS200) || defined(HPT5K0TS200_LOWPROFILE) || defined(HPL5K0TS200))
#define HPT5K_200V 1
#endif
#if (defined(HPT5K0TS400) || defined(HPT5K0TS400_LOWPROFILE) || defined(HPL5K0TS400))
#define HPT5K_400V 1
#endif
#if (defined(HPT5K0TS800) || defined(HPT5K0TS800_LOWPROFILE) || defined(HPL5K0TS800))
#define HPT5K_800V 1
#endif

#define MFR_PRODUCT_CODE_PHASE	MFR_PRODUCT_CODE_PHASE_3	// phase#

#ifdef HPT5K_LOW_PROFILE
#define FAN_INSTALLED	3
#define MFR_PRODUCT_CODE_PROFILE	MFR_PRODUCT_CODE_PROFILE_LOW
#else
#define FAN_INSTALLED	1
#define MFR_PRODUCT_CODE_PROFILE	MFR_PRODUCT_CODE_PROFILE_STD
#endif

#ifdef HPT5K_LOW_LINE
// Low line only (no power derating)
#define MFR_PRODUCT_CODE_LINE	MFR_PRODUCT_CODE_LINE_LOW
#define AC_OK_PK_LL			124u
#define AC_OK_PK_HL			230u
#define PFC_OK_LIMIT		380u
#define CAL_DCBUS_VOLTAGE	394u

#define MFR_VIN_MIN			180			// V RNS
#define MFR_VIN_MAX			264			// V RMS
#define MFR_IIN_MAX			20			// A RMS
#define MFR_PIN_MAX			5500		// W
#define MFR_LINEAR_PIN_MAX	0x1AB0		// 5500w, linear format
#define MFR_VIN_OVP			280			// V RMS
#define MFR_VIN_UVP			170			// V RMS

#else
// High and Low line (power derating at low line)
#define MFR_PRODUCT_CODE_LINE	MFR_PRODUCT_CODE_LINE_HL
#define AC_OK_PK_LL			248u
#define AC_OK_PK_HL			460u
#define PFC_OK_LIMIT		760u
#define CAL_DCBUS_VOLTAGE	788u

#define MFR_VIN_MIN			180			// V RNS
#define MFR_VIN_MAX			528			// V RMS
#define MFR_IIN_MAX			10			// A RMS
#define MFR_PIN_MAX			5500		// W
#define MFR_LINEAR_PIN_MAX	0x1AB0		// 5500w, linear format
#define MFR_VIN_OVP			540			// V RMS
#define MFR_VIN_UVP			170			// V RMS

#define MFR_LL_POUT_MAX		3400ul 		// W, power limit at low line
#define MFR_LINEAR_LL_POUT_MAX 0x1352 	// W, MFR_LL_POUT_MAX in linear format
#endif

//----- HPT5K 48V -----
#ifdef HPT5K_48V

#define MFR_PRODUCT_CODE_VOLTAGE 	MFR_PRODUCT_CODE_VOLTAGE_48V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT		'H','P','L','5','K','0','T','S','4','8','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','4','8','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','4','8','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN		0			// V
#define MFR_VOUT_MAX		50.4		// V
#define MFR_VOUT_NOMINAL	48l			// V
#define MFR_VOUT_DEFAULT	48			// V output voltage setting by default

#define MFR_VOUT_MIN_RVU		0
#define MFR_VOUT_MAX_RVU		(12903)		// 50.4v * RVU
#define MFR_VOUT_NOMINAL_RVU 	(MFR_VOUT_NOMINAL * RVU)
#define MFR_VOUT_DEFAULT_RVU	(MFR_VOUT_NOMINAL * RVU)	// output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU	(11796)		// 46.08 * RVU
#define VOUT_UV_FAULT_LIMIT_RVU	(11673)		// 45.6 * RVU

#define MFR_IPROG_RVI_MAX	((11458*RVI)/100)	// A IPROG : 5v-> 110% not MFR_IOUT_MAX (114.58A -> 110%)
#define MFR_IOUT_MAX		113			// A
#define MFR_IOUT_NOMINAL	104			// A
#define MFR_POUT_MAX		5000		// W
#define MFR_LINEAR_POUT_MAX	0x1A71		// 5000w, linear format

#define MFR_VOUT_OVP		56			// V
#define MFR_VOUT_OVPW		54			// V
#define MFR_VOUT_UVP		0			// V

#define MFR_SEC_OTP			135			// C
#define MFR_SEC_OTP_WARNING	130			// C
#define MFR_PRI_OTP			90			// C
#define MFR_PRI_OTP_WARNING	86			// C

//----- HPT5K 60V -----
#elif HPT5K_60V

#define MFR_PRODUCT_CODE_VOLTAGE 	MFR_PRODUCT_CODE_VOLTAGE_60V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT		'H','P','L','5','K','0','T','S','6','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','6','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','6','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN		0			// V
#define MFR_VOUT_MAX		63			// V
#define MFR_VOUT_NOMINAL	60			// V
#define MFR_VOUT_DEFAULT	60			// V output voltage setting by default

#define MFR_VOUT_MIN_RVU		0		// V * RVU
#define MFR_VOUT_MAX_RVU		(MFR_VOUT_MAX * RVU)		// V * RVU
#define MFR_VOUT_NOMINAL_RVU 	(MFR_VOUT_NOMINAL * RVU)	// V * RVU
#define MFR_VOUT_DEFAULT_RVU	(MFR_VOUT_NOMINAL * RVU)	// V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU	(58*RVU)	// linear format 58v
#define VOUT_UV_FAULT_LIMIT_RVU	(57*RVU)	// linear format 57v

#define MFR_IPROG_RVI_MAX	((9167*RVI)/100)	// A IPROG : 5v-> 110% not MFR_IOUT_MAX (91.67A -> 110%)
#define MFR_IOUT_MAX		90			// A
#define MFR_IOUT_NOMINAL	84			// A
#define MFR_POUT_MAX		5000		// W
#define MFR_LINEAR_POUT_MAX	0x1A71		// 5000w, linear format

#define MFR_VOUT_OVP		69			// V
#define MFR_VOUT_OVPW		67			// V
#define MFR_VOUT_UVP		0			// V

#define MFR_SEC_OTP			130			// C
#define MFR_SEC_OTP_WARNING	125			// C
#define MFR_PRI_OTP			90			// C
#define MFR_PRI_OTP_WARNING	86			// C

//----- HPT5K 80V -----
#elif HPT5K_80V

#define MFR_PRODUCT_CODE_VOLTAGE 	MFR_PRODUCT_CODE_VOLTAGE_80V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT		'H','P','L','5','K','0','T','S','8','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','8','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','8','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN		0			// V
#define MFR_VOUT_MAX		84			// V
#define MFR_VOUT_NOMINAL	80			// V
#define MFR_VOUT_DEFAULT	80			// V output voltage setting by default

#define MFR_VOUT_MIN_RVU		0		// V * RVU
#define MFR_VOUT_MAX_RVU		(MFR_VOUT_MAX * RVU)	// V * RVU 105%
#define MFR_VOUT_NOMINAL_RVU 	(MFR_VOUT_NOMINAL * RVU)	// V * RVU 100%
#define MFR_VOUT_DEFAULT_RVU	(MFR_VOUT_NOMINAL * RVU)	// V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU	(77*RVU)	// linear format
#define VOUT_UV_FAULT_LIMIT_RVU	(76*RVU)	// linear format

#define MFR_IPROG_RVI_MAX	(((6875*RVI)/100))	// A IPROG : 5v-> 110% not MFR_IOUT_MAX (68.75A -> 110%)
#define MFR_IOUT_MAX		68			// A
#define MFR_IOUT_NOMINAL	63			// A
#define MFR_POUT_MAX		5000		// W
#define MFR_LINEAR_POUT_MAX	0x1A71		// 5000w, linear format

#define MFR_VOUT_OVP		92			// V
#define MFR_VOUT_OVPW		90			// V
#define MFR_VOUT_UVP		0			// V

#define MFR_SEC_OTP			115			// C
#define MFR_SEC_OTP_WARNING	106			// C
#define MFR_PRI_OTP			90			// C
#define MFR_PRI_OTP_WARNING	86			// C

//----- HPT5K 100V -----
#elif HPT5K_100V

#define MFR_PRODUCT_CODE_VOLTAGE 	MFR_PRODUCT_CODE_VOLTAGE_100V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT		'H','P','L','5','K','0','T','S','1','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','1','0','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','1','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN		0			// V
#define MFR_VOUT_MAX		105			// V
#define MFR_VOUT_NOMINAL	100			// V
#define MFR_VOUT_DEFAULT	100			// V output voltage setting by default

#define MFR_VOUT_MIN_RVU		0		// V * RVU
#define MFR_VOUT_MAX_RVU		(MFR_VOUT_MAX * RVU)		// V * RVU
#define MFR_VOUT_NOMINAL_RVU 	(MFR_VOUT_NOMINAL * RVU)	// V * RVU
#define MFR_VOUT_DEFAULT_RVU	(MFR_VOUT_NOMINAL * RVU)	// V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU	(96*RVU)	// linear format
#define VOUT_UV_FAULT_LIMIT_RVU	(95*RVU)	// linear format

#define MFR_IPROG_RVI_MAX	(55*RVI)	// A IPROG : 5v-> 110% not MFR_IOUT_MAX
#define MFR_IOUT_MAX		54			// A
#define MFR_IOUT_NOMINAL	50			// A
#define MFR_POUT_MAX		5000		// W
#define MFR_LINEAR_POUT_MAX	0x1A71		// 5000w, linear format

#define MFR_VOUT_OVP		115			// V
#define MFR_VOUT_OVPW		112			// V
#define MFR_VOUT_UVP		0			// V

#define MFR_SEC_OTP			110			// C
#define MFR_SEC_OTP_WARNING	106			// C
#define MFR_PRI_OTP			90			// C
#define MFR_PRI_OTP_WARNING	86			// C

//----- HPT5K 200V -----
#elif HPT5K_200V

#define MFR_PRODUCT_CODE_VOLTAGE 	MFR_PRODUCT_CODE_VOLTAGE_200V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT		'H','P','L','5','K','0','T','S','2','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','2','0','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT		'H','P','T','5','K','0','T','S','2','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN		0			// V
#define MFR_VOUT_MAX		210			// V
#define MFR_VOUT_NOMINAL	200u			// V
#define MFR_VOUT_DEFAULT	200			// V output voltage setting by default

#define MFR_VOUT_MIN_RVU		0		// V * RVU
#define MFR_VOUT_MAX_RVU		(MFR_VOUT_MAX * RVU) //53760	// V * RVU
#define MFR_VOUT_NOMINAL_RVU 	(MFR_VOUT_NOMINAL * RVU) //51200	// V * RVU
#define MFR_VOUT_DEFAULT_RVU	(MFR_VOUT_NOMINAL * RVU) //51200	// V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU	(192 * RVU)	// linear format
#define VOUT_UV_FAULT_LIMIT_RVU	(190 * RVU)	// linear format

#define MFR_IPROG_RVI_MAX	((275*RVI)/10)	// A IPROG : 5v-> 110% not MFR_IOUT_MAX, 27.5A
#define MFR_IOUT_MAX		27			// A 108%
#define MFR_IOUT_NOMINAL	25u			// A
#define MFR_POUT_MAX		5000		// W
#define MFR_LINEAR_POUT_MAX	0x1A71		// 5000w, linear format

#define MFR_VOUT_OVP		230			// V
#define MFR_VOUT_OVPW		224			// V
#define MFR_VOUT_UVP		0			// V

#define MFR_SEC_OTP			110			// C
#define MFR_SEC_OTP_WARNING	106			// C
#define MFR_PRI_OTP			90			// C
#define MFR_PRI_OTP_WARNING	86			// C

//----- HPT5K 400V -----
#elif HPT5K_400V

#define MFR_PRODUCT_CODE_VOLTAGE    MFR_PRODUCT_CODE_VOLTAGE_400V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT      'H','P','L','5','K','0','T','S','4','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT      'H','P','T','5','K','0','T','S','4','0','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT      'H','P','T','5','K','0','T','S','4','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN        0           // V
#define MFR_VOUT_MAX        420         // V
#define MFR_VOUT_NOMINAL    400u        // V
#define MFR_VOUT_DEFAULT    400         // V output voltage setting by default

#define MFR_VOUT_MIN_RVU        0       // V * RVU
#define MFR_VOUT_MAX_RVU        (MFR_VOUT_MAX * RVU) //53760    // V * RVU
#define MFR_VOUT_NOMINAL_RVU    (MFR_VOUT_NOMINAL * RVU) //51200    // V * RVU
#define MFR_VOUT_DEFAULT_RVU    (MFR_VOUT_NOMINAL * RVU) //51200    // V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU  (384 * RVU) // linear format
#define VOUT_UV_FAULT_LIMIT_RVU (380 * RVU) // linear format

#define MFR_IPROG_RVI_MAX   ((13.8*RVI)/10)  // A IPROG : 5v-> 110% not MFR_IOUT_MAX, 13.75A
#define MFR_IOUT_MAX        14          // A 110% 13.75A
#define MFR_IOUT_NOMINAL    12u         // A 12.5A
#define MFR_POUT_MAX        5000        // W
#define MFR_LINEAR_POUT_MAX 0x1A71      // 5000w, linear format

#define MFR_VOUT_OVP        460         // V
#define MFR_VOUT_OVPW       448         // V
#define MFR_VOUT_UVP        0           // V

#define MFR_SEC_OTP         110         // C
#define MFR_SEC_OTP_WARNING 106         // C
#define MFR_PRI_OTP         90          // C
#define MFR_PRI_OTP_WARNING 86          // C

//----- HPT5K 800V -----
#elif HPT5K_800V

#define MFR_PRODUCT_CODE_VOLTAGE    MFR_PRODUCT_CODE_VOLTAGE_800V

#ifdef HPT5K_LOW_LINE
#define MFR_MODEL_DFLT      'H','P','L','5','K','0','T','S','8','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#elif HPT5K_LOW_PROFILE
#define MFR_MODEL_DFLT      'H','P','T','5','K','0','T','S','8','0','0','-','L','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#else
#define MFR_MODEL_DFLT      'H','P','T','5','K','0','T','S','8','0','0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'
#endif

#define MFR_VOUT_MIN        0           // V
#define MFR_VOUT_MAX        840         // V
#define MFR_VOUT_NOMINAL    800l        // V
#define MFR_VOUT_DEFAULT    800         // V output voltage setting by default

#define MFR_VOUT_MIN_RVU        0       // V * RVU
#define MFR_VOUT_MAX_RVU        (MFR_VOUT_MAX * RVU) //53760    // V * RVU
#define MFR_VOUT_NOMINAL_RVU    (MFR_VOUT_NOMINAL * RVU) //51200    // V * RVU
#define MFR_VOUT_DEFAULT_RVU    (MFR_VOUT_NOMINAL * RVU) //51200    // V * RVU, output voltage setting by default
#define VOUT_UV_WARN_LIMIT_RVU  (768 * RVU) // linear format 94%
#define VOUT_UV_FAULT_LIMIT_RVU (760 * RVU) // linear format 95%

#define MFR_IPROG_RVI_MAX   ((625*RVI)/100)  // A IPROG : 5v-> 110% not MFR_IOUT_MAX, 6.875A
#define MFR_IOUT_MAX        7          // A 110% 6.875A
#define MFR_IOUT_NOMINAL    6u         // A 6.25A
#define MFR_POUT_MAX        5000        // W
#define MFR_LINEAR_POUT_MAX 0x1A71      // 5000w, linear format

#define MFR_VOUT_OVP        920         // V
#define MFR_VOUT_OVPW       896         // V
#define MFR_VOUT_UVP        0           // V

#define MFR_SEC_OTP         110         // C
#define MFR_SEC_OTP_WARNING 106         // C
#define MFR_PRI_OTP         90          // C
#define MFR_PRI_OTP_WARNING 86          // C
#endif

#if defined(HPT5K0TS048_LOWPROFILE) || defined(HPL5K0TS048)
#define VLOOP_COEFF_RAMP_CHG	1
#endif

// define product code based on setting
#define MFR_PRODUCT_CODE (MFR_PRODUCT_CODE_VOLTAGE | MFR_PRODUCT_CODE_PHASE | MFR_PRODUCT_CODE_LINE | MFR_PRODUCT_CODE_PROFILE)

#endif	// SETUP_H
