/******************************************************************************
 *  File: state.c
 *  Description: state machine for secondary
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 *****************************************************************************/
#include "main.h"
#include "state.h"
#include "control.h"
#include "timer.h"
#include "restart.h"
#include "flashInterface.h"
#include "pmbus.h"
#include "preload.h"
#include "power.h"
#include "primary.h"
#include "pri_comm.h"
#include "calibration.h"
#include "digital_io.h"


static uint8_t inp_early_warning_cnt = 0;
static uint16_t turn_on_delay;
static uint16_t pfc_ok_timer;

state_t state;
uint16_t ramp_up;
uint8_t ramp_up_delay;
uint8_t state_calibration;
int16_t calibration_delay;

void state_init(void)
{
	voltage.u_ref = 0;
	current.i_ref = 0;
	state.state = STATE_INIT;
	state_calibration = 0;
	SYNC_SIG_OFF();
	ramp_up = (uint16_t)pmbus_real_mfr_config.ramp_up_voltage;
}

// run every 250us
#pragma CODE_SECTION(state_process, ".TI.ramfunc");
/*__attribute__ ((section(".mydata")))*/ void state_process(void)
{

}

void state_init_process(void)
{
	pfc_ok_timer = 0;
	turn_on_delay = 0;
}

void state_off_process(void)
{

}

void state_goto_walkin(void)
{

}

void state_voltage_walking_process(void)
{

}

void state_current_walking_process(void)
{

}

void state_goto_on(void)
{

}

/////////////////////////////////////////
// current control reference ramp up/down
// should be executed every 1ms
/////////////////////////////////////////
#pragma CODE_SECTION(state_current_control_reference, ".TI.ramfunc");
void state_current_control_reference(void)
{

}

// run every 250us when in ON state
// vout_pot_adj range is +-2929 (+-11%)
/*__attribute__ ((section(".mydata")))*/ void state_run_process(void)
{

}

/*__attribute__ ((section(".mydata")))*/ void voltage_loop_coefficient(void)
{

}

void state_llc_pwm_off(void)
{

}

void state_llc_pwm_on(void)
{
	ctrl_modulo = MODULO_MIN_CTRL;
	voltage.verr_z1 = 0;
	voltage.verr_delta = 0;
	current.iout_adc_z1 = 0;

	CLEAR_OV_FAULT();
	PWM_FAULT_OCP_ISR_CLEAR();
	PWM_FAULT_OCP_ISR_ENABLE();
	status.bits.pwm_enable = 1;
	CONTROL_UNMASK_OUPUT();				// enable all LLC pwms outputs
}

// every 250us if in calibration process
void state_calibration_process(void)
{

}

// every 250us if in test process
void state_test_mode_process(void)
{
	static int16_t test_mode_delay = 0;
	uint16_t i;

	if(test_mode_delay > 2000)
	{
//		ACOK_LED_TGL();
//		ACOK_SIG_TGL();
		for(i = 0; i < 1500u ; i++)
		{
			test_mode_delay = 0;
		}
	}
	test_mode_delay++;
}
