/******************************************************************************
 *  File: timer.h
 *  Description:
 *  Author: Arnaud Hugron
 *  Date: 08/13/2015
 ****************************************************************************/
#ifndef TIMER_H_
#define TIMER_H_

#include "main.h"
#include "setup.h"

#ifdef OPEN_LOOP
void open_loop_timer(void);
extern uint8_t open_loop_state;
#endif

void timer_init (void);
void timer_process(void);
void wdog_init(void);

// 250us timer
#define IS_TIMER_SET()  ((HWREG(CPUTIMER0_BASE+CPUTIMER_O_TCR) & CPUTIMER_TCR_TIF) != 0u)
#define TIMER_CLEAR()   (HWREG(CPUTIMER0_BASE+CPUTIMER_O_TCR) = CPUTIMER_TCR_TIF)

// 80us timer
#define IS_BRK_TIMER_SET()  ((HWREG(CPUTIMER1_BASE+CPUTIMER_O_TCR) & CPUTIMER_TCR_TIF) != 0u)
#define TIMER_BRK_CLEAR()   (HWREG(CPUTIMER1_BASE+CPUTIMER_O_TCR)=CPUTIMER_TCR_TRB); (HWREG(CPUTIMER1_BASE+CPUTIMER_O_TCR) = CPUTIMER_TCR_TIF)

#define TIMER_ARM(timer, ticks) 	timer = ticks
#define TIMER_HAS_EXPIRED(timer) 	(timer == 0u)

#endif /* TIMER_H_ */
