/*
 * utils.c
 *
 *  Created on: Dec 7, 2016
 *      Author: ahugron
 */
#include <string.h>
//#include "scpi.h"
//#include "calibration.h"
#include "main.h"
#include "utils.h"

#ifdef O3_CODE
#pragma GCC optimize ("O3")
#endif

bool_t IsWhiteSpace(char_t cByte)
{
	if ( cByte == (char_t)0x09 ) { return TRUE; }	//	Horizontal Tab
	if ( cByte == (char_t)0x0A ) { return TRUE; }	//	Line Feed
	if ( cByte == (char_t)0x0B ) { return TRUE; }	//	Vertical Tab
	if ( cByte == (char_t)0x0C ) { return TRUE; }	//	Form Feed
	if ( cByte == (char_t)0x0D ) { return TRUE; }	//	Carriage Return
	if ( cByte == (char_t)0x1C ) { return TRUE; }	//	File Separator
	if ( cByte == (char_t)0x1D ) { return TRUE; }	//	Group Separator
	if ( cByte == (char_t)0x1E ) { return TRUE; }	//	Record Separator
	if ( cByte == (char_t)0x1F ) { return TRUE; }	//	Unit Separator
	if ( cByte == (char_t)0x20 ) { return TRUE;	}	//	Blank

	return FALSE;
}

bool_t IsUpperCase(char_t cByte)
{
	if((cByte >= 'A') && (cByte <= 'Z'))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

bool_t IsLowerCase(char_t cByte)
{
	if((cByte >= 'a') && (cByte <= 'z'))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

bool_t IsNumeric(char_t cByte)
{
	if((cByte >= '0') && (cByte <= '9'))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

char_t UpperCase(char_t cByte)
{
	int32_t tt;

	if(IsLowerCase(cByte) == TRUE)
	{
		tt = (int32_t)cByte - (int32_t)' ';
		return (char_t)(tt);
	}
	else
	{
		return cByte;
	}
}

// Is binary digit string
bool_t isBdigitstr(const char_t *str)
{
	while((*str != '\0') && (((*str == '0') || (*str == '1'))))
	{
		str++;
	}
	if(*str == '\0')
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

// Is hexadecimal string
bool_t isXdigitstr(const char_t *str)
{
	while((*str != '\0') && (((*str >= '0') && (*str <= '9')) || ((*str >= 'A') && (*str <= 'F')) || ((*str >= 'a') && (*str <= 'f'))))
	{
		str++;
	}

	if(*str == '\0')
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

// Is octodecimal string
bool_t isQdigitstr(const char_t *str)
{
	while((*str != '\0') && ((*str >= '0') && (*str <= '7')))
	{
		str++;
	}

	if(*str == '\0')
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

// return 	-1: not a number
//			0: decimal
//			1: float
int32_t isNumberdigitstr(const char_t *str)
{
	int32_t pointCnt = 0;

	if(*str == '-')
	{
		return -1;		// do not support negative number
	}

	if(*str == '+')
	{
		str++;
	}

	while((*str != '\0') && (((*str >= '0') && (*str <= '9')) || (*str == '.')))
	{
		if(*str == '.')
		{
			pointCnt++;
		}
		str++;
	}
	if(*str == '\0')
	{
		if(pointCnt == 0)
		{
			return 0;
		}
		else if(pointCnt == 1)
		{
			return 1;
		}
		else
		{
			return -1;
		}
	}
	return -1;
}

char_t *strtok1(char_t *s , char_t *delim)
{
	register const char_t *spanp;
	register char_t c;
	register char_t sc;
	char_t *tok;
	static char_t *last;

	if(s == NULL)
	{
		if(last == NULL)
		{
			return (NULL);
		}
		s = last;
	}

	// Skip (span) leading delimiters (s += strspn(s, delim), sort of).
cont:
	c = *s;
	s++;
	spanp = (char_t *)delim;
	for( sc = *spanp ; sc != '\0' ; )
	{
		if (c == sc)
		{
			goto cont;
		}
		spanp++;
		sc = *spanp;
	}

	if (c == '\0')
	{	// no non-delimiter characters
		last = NULL;
		return (NULL);
	}
	tok = s - 1;

	// Scan token (scan for delimiters: s += strcspn(s, delim), sort of).
	// Note that delim must have one NUL; we stop if we see that, too.
	for( ; ; )
	{
		c = *s;
		s++;
		spanp = (char_t *)delim;
		do
		{
			sc = *spanp;
			spanp++;
			if(sc == c)
			{
				if (c == '\0')
				{
					s = NULL;
				}
				else
				{
					s[-1] = '\0';
				}
				last = s;
				return (tok);
			}
		} while (sc != '\0');
	}
	// NOTREACHED
_TI_PROPRIETARY_PRAGMA("diag_push")
_TI_PROPRIETARY_PRAGMA("diag_suppress 112")
	return(NULL);
_TI_PROPRIETARY_PRAGMA("diag_pop")
}

// return the number of byte copy
uint16_t strncpy1(char_t *s1, const char_t *s2, size_t n)
{
    char_t *s = s1;
    uint16_t count = 0;

    while ((n > 0u) && (*s2 != '\0'))
    {
		*s = *s2;
		s++;
		s2++;
		--n;
		count++;
    }
    if (n > 0u)
    {
    	*s = '\0';
    }
    return (count);
}

/*
 * Appends src to string dst of size siz (unlike strncat, siz is the
 * full size of dst, not space left).  At most siz-1 characters
 * will be copied.  Always NUL terminates (unless siz <= strlen(dst)).
 * Returns Return the number of total bytes used in buffer dst min of (src + dst) or siz
 */
uint16_t strlcat1(char_t *dst, const char_t *src, uint16_t siz)
{
	char_t *d = dst;
	const char_t *s = src;
	uint16_t n = siz;
	uint16_t dlen = 0;

	// Find the end of dst and adjust bytes left but don't go past end
	while ((n-- != 0u) && (*d != '\0'))
	{
		d++;
		dlen++;
	}
	n = siz - dlen;

	if (n == 0u)
	{
		return(dlen);
	}
	while (*s != '\0')
	{
		if (n != 1u)
		{
			*d = *s;
			d++;
			n--;
			dlen++;
		}
		s++;
	}
	*d = '\0';
	return(dlen);		// count does not include NUL
}

// Skip all leading spaces, return pointer after all spaces
char_t *skipWs(char_t *str)
{
	char_t *end;

	// remove leading space
	while((str[0] != '\0') && ((str[0] == ' ') || (str[0] == '\t')))
	{
    	str++;
	}

	if(str[0] == '\0')			// all spaces or no string
	{
		return str;
	}

	// remove trailing space
	end = str;
	while(end[0] != '\0')
	{
		end++;
	}
	end--;
	while(((uint32_t)end > (uint32_t)str) && ((end[0] == ' ') || (end[0] == '\t')))
	{
		end--;
	}
	end[1] = '\0';
    return(str);
}

void reverse(char_t *str)
{
    uint32_t i;
	uint32_t j;
    char_t c;

    j = strlen(str);
    j--;

    for(i = 0 ; i < j ; i++)
    {
        c = str[i];
        str[i] = str[j];
        str[j] = c;
        j--;
    }
}

// convert integer into ascii
// Return the number of bytes used in buffer
uint16_t itoa(int32_t n, char_t *str)
{
	uint16_t i;
	int32_t sign;

	sign = n;

	if (n < 0)
	{
		n = -n;
	}
	i = 0;
	do
	{
		str[i] = (char_t)((n % 10) + '0');
		i++;
		n = (n / (int32_t)10);
	} while (n != 0);

	if (sign < 0)
	{
		str[i] = '-';
		i++;
	}
	str[i] = '\0';
	reverse(str);
	return i;
}

uint16_t uitoa(uint32_t n, char_t *str)
{
	uint16_t i = 0;

    do
    {
    	str[i] = (char_t)((n % 10u) + '0');
    	i++;
    	n = (n / (uint32_t)10);
    } while (n > 0u);

    str[i] = '\0';
    reverse(str);
    return i;
}

uint16_t uitoab(uint32_t n, char_t *str, uint16_t base)
{
	uint16_t i = 0;

    // Handle 0 explicitly, otherwise empty string is printed for 0
    if (n == 0u)
    {
        str[i] = '0';
        i++;
        str[i] = '\0';
        return 1;
    }

    // Process individual digits
    while (n != 0u)
    {
    	uint32_t rem = n % base;
        str[i] = (rem > 9u) ? (char_t)((rem-10u) + 'A') : (char_t)(rem + '0');
        i++;
        n /= base;
    }
    str[i] = '\0'; 		// Append string terminator
    reverse(str);		// Reverse the string
    return i;
}

/**************************************************
 *    ftoa - converts float to string
 *    This is a simple fast implementation:
 *            - Buffer must be 8 chars long
 *            - 3 digits precision max
 *            - absolute range is -524,287 to 524,287
 *            - resolution is 0.0625 and always rounds down
 *    Return the number of bytes used in buffer
 **************************************************/
uint16_t ftoa(float Value, char_t *str)
 {
     union
     {
         float f;
         struct
         {
             uint32_t mantissa : 23;    // check change from unsigned to uint32_t TBD
             uint32_t exponent : 8;
             uint32_t sign : 1;
         }s;
     } float_format;	// according to  IEEE754 (https://en.wikipedia.org/wiki/Single-precision_floating-point_format)

     uint32_t mantissa;
     int32_t exponent;
     uint32_t int_part;
     uint32_t count = 0;
     int32_t iTemp;

     float_format.f = Value;
     mantissa = (uint32_t)float_format.s.mantissa;	//mantissa is LS 23 bits
     mantissa += 0x00800000u;						//add the 24th bit to get 1.mmmm^eeee format
     exponent = (int32_t)float_format.s.exponent - (int32_t)127;		//exponent is biased by 127

     if (exponent > 18)							//too big to shove into 8 chars
     {
         str[0] = '0';
         str[1] = '\0';
         return 1;
     }

     if (exponent < -4)							//too small to resolve (resolution of 1/16)
     {
         str[0] = '0';
         str[1] = '\0';
         return 1;
     }

     if(float_format.s.sign == 1u)				//add negative sign (if applicable)
     {
         str[0] = '-';
         count++;
     }

     iTemp = ((int32_t)23 - exponent);
     int_part = (uint32_t)iTemp;
     int_part = (mantissa >> int_part);			//get the integer part
     count += (uint32_t)itoa((int32_t)int_part, &str[count]);	//convert to string

     if (count > 6u)
     {
         str[0] = '0';
         str[1] = '\0';
         return 1;
     }

     /*lint -save -e9049*/
     str[count++] = '.';				//add the decimal point

     exponent = ((int32_t)19 - exponent);
     int_part = (uint32_t)exponent;
     //use switch to resolve the fractional part
     switch ((mantissa >> int_part) & 0x0Fu)
     {
         case 0:
        	 str[count++] = '0';
             break;
         case 1:
        	 str[count++] = '0';
        	 str[count++] = '6';
        	 str[count++] = '2';
        	 break;
         case 2:
        	 str[count++] = '1';
        	 str[count++] = '2';
        	 str[count++] = '5';
             break;
         case 3:
        	 str[count++] = '1';
        	 str[count++] = '8';
        	 str[count++] = '7';
        	 break;
         case 4:
        	 str[count++] = '2';
        	 str[count++] = '5';
             break;
         case 5:
        	 str[count++] = '3';
        	 str[count++] = '1';
        	 str[count++] = '2';
        	 break;
         case 6:
        	 str[count++] = '3';
        	 str[count++] = '7';
        	 str[count++] = '5';
             break;
         case 7:
        	 str[count++] = '4';
        	 str[count++] = '3';
        	 str[count++] = '7';
        	 break;
         case 8:
             str[count++] = '5';
             break;
         case 9:
        	 str[count++] = '5';
        	 str[count++] = '6';
        	 str[count++] = '2';
        	 break;
         case 10:
             str[count++] = '6';
             str[count++] = '2';
             str[count++] = '5';
             break;
         case 11:
        	 str[count++] = '6';
        	 str[count++] = '8';
        	 str[count++] = '7';
        	 break;
         case 12:
             str[count++] = '7';
             str[count++] = '5';
             break;
         case 13:
        	 str[count++] = '8';
        	 str[count++] = '1';
        	 str[count++] = '2';
        	 break;
         case 14:
             str[count++] = '8';
             str[count++] = '7';
             str[count++] = '5';
             break;
         case 15:
        	 str[count++] = '9';
        	 str[count++] = '3';
        	 str[count++] = '7';
        	 break;
         default:
        	 // should not be here
        	 break;
     }
     str[count] = '\0';				//make sure the output is terminated
     return (uint16_t)count;
 }
/*lint -restore */

 // convert a string (float_t or interger), do not support negative number
 // we limit the resolution to 3 decimal after the '.'
 // and 4 decimal before the '.', max number is 9999.999, min is 0
 // return -1 if there is a problem
 float_t atof1(const char_t *str)
 {
	uint16_t i;
	uint16_t indx = 0;
	uint16_t fract = 0;
	uint32_t sum = 0;
	uint32_t total;

	if(*str == '-')
	{
		return (float_t)-1;			// do not support negative number
	}

	if(*str == '+')					// skip + sign
	{
		str++;
	}

 	i = 0;
	while((str[i] != '\0') && (indx < 3u))
	{
		if(fract > 0u)
		{
			indx++;
		}
		else
		{
			if(i > 4u)
			{
				return (float_t)-1;	// too big number
			}
		}

		if(str[i] == '.')
		{
			indx = 0;
			fract++;
			i++;
			continue;
		}

		if(!((str[i] >= '0') && (str[i] <= '9')))
		{
			return (float_t)-1;
		}

		total = (uint32_t)((uint8_t)str[i]) - (uint32_t)'0';
		if(i == 0u)
		{
			sum = total;
			i++;
			continue;
		}
		sum = (sum * 10u)  + total;
		i++;
	}
	if(fract > 1u)
	{
		return (float_t)-1;
	}

	if(indx == 1u)
	{
		return ((float_t)sum / (float_t)10);
	}
	else if(indx == 2u)
	{
		return ((float_t)sum / (float_t)100);
	}
	else if(indx == 3u)
	{
		return ((float_t)sum / (float_t)1000);
	}
	else
	{
		return (float_t)sum;
	}
}

 uint16_t bin_to_hexstr(const uint8_t *bin, uint16_t binsz, char_t *result, uint16_t resp_size_max)
{
	 static const char_t hex_str[]= "0123456789ABCDEF";
	 uint16_t i;
	 uint16_t cnt;

	if((binsz == 0u) && (resp_size_max < 8u))
	{
		result[0] = '\0';
		return 0;
	}

	if(binsz > 2u)
	{
		binsz--;			// for packet more than 2 bytes, we have the size included in the pkt, remove it
		bin++;
	}

	result[0] = '#';
	result[1] = 'H';

	cnt = 2;
	for (i = 0 ; i < binsz ; i++)
	{
		if(cnt < (resp_size_max-2u))
		{
			result[(i*2u)+2u] = hex_str[(bin[i] >> 4u) & 0x0Fu];
			result[(i*2u)+3u] = hex_str[bin[i] & 0x0Fu];
			cnt += 2u;
		}
		else
		{
			break;
		}
	}
	result[cnt] = '\0';
	return cnt;
}

 /*lint -save -e9044*/
 uint16_t hexstr_to_bin(uint8_t *hexstr, uint8_t *bin, uint16_t bin_size_max)
 {
	uint32_t valmsb;
	uint32_t vallsb;
	uint16_t cnt;

	hexstr = (uint8_t*)skipWs((char*)hexstr);

	if(!((hexstr[0] == (uint8_t)'#') && ((hexstr[1] == (uint8_t)'h') || (hexstr[1] == (uint8_t)'H'))))
	{
		return 0;
	}

	hexstr++;
	hexstr++;

	cnt = 0;
	while((*hexstr != (uint8_t)'\0') && (cnt < bin_size_max))
	{
		if((*hexstr >= (uint8_t)'0') && (*hexstr <= (uint8_t)'9'))
		{
			valmsb = (uint32_t)*hexstr - (uint32_t)'0';
		}
		else if((*hexstr >= (uint8_t)'a') && (*hexstr <= (uint8_t)'f'))
		{
			valmsb = (uint32_t)*hexstr - (uint32_t)'a' + 0x0Au;
		}
		else if((*hexstr >= (uint8_t)'A') && (*hexstr <= (uint8_t)'F'))
		{
			valmsb = (uint32_t)*hexstr - (uint32_t)'A' + 0x0Au;
		}
		else
		{
			return 0;
		}

		hexstr++;
		if((*hexstr >= (uint8_t)'0') && (*hexstr <= (uint8_t)'9'))
		{
			vallsb = (uint32_t)*hexstr - (uint32_t)'0';
		}
		else if((*hexstr >= (uint8_t)'a') && (*hexstr <= (uint8_t)'f'))
		{
			vallsb = (uint32_t)*hexstr - (uint32_t)'a' + 0x0Au;
		}
		else if((*hexstr >= (uint8_t)'A') && (*hexstr <= (uint8_t)'F'))
		{
			vallsb = (uint32_t)*hexstr - (uint32_t)'A' + 0x0Au;
		}
		else
		{
			return 0;
		}

		bin[cnt] = (uint8_t)((16u * valmsb) + vallsb);
		cnt++;
		hexstr++;
	}
	return cnt;
 }
 /*lint -restore */
